# MohAwk is a hacked version of the awk programming language. 
# We abuse the callback functionality of awk in order to 
# trigger other events such as midi notes or audio callback 
# functions. As in awk, the BEGIN block is copleted before any
# callbacks are run.  
BEGIN { 
#	the openaudio function opens a soundfile and gives back an
#	identifyer which points to a collection of windows. Iterators 
#   be used, but currently a single iterator is built into the 
#   collection. This allows to call 'getwindow(col, NEXT) to 
#   traverse a single collection
	recording = openaudio("perry.au");
	last = getwindow(recording, LAST);
	first = getwindow(recording, FIRST);
	win = first;

#	Parameters for effects are set with the 'seteffect' function.
#	Valid effects are   TSHIFT	timeshift factor
#						PSHIFT	pitchshift factor
#						HOPSZ	windowsize for timeshifting
#						SOLA    the number of samples to try to get better overlaps
#						PAN		

	seteffect(TSHIFT, 1);
	pass = 0;
}

# ONTICK is called every time the default audio stream needs a new 
# buffer of sound to play. 'getwindow' gets the specified window from
# the specified collection. The identifier returned can then be used in
# 'play' to play the window for the current stream. The second aregument to 'play'
# is the gain. Giving the window identifier preceded by a negative sign plays the
# window backwards.
/ONTICK/ {
	if(pass % 2 == 0) 
	{
		play(win, 1.0);
		win = getwindow(recording, NEXT);
	}
	else
	{
		play(-win, 1.0)
		win = getwindow(recording, PREVIOUS);
	}
	if(win == first || win == last) pass++;

}
