# setstream sets the current stream to the given argument. If the
# stream does not exist, then the stream is created. Every existing
# stream calls the callback function with its name whenever it needs
# a new window to play. In this case, stream names are ints from 0
# to 15. We can deal with all the streams in one callback function
# by using a regular expression. Calling 'newcollection' copys the 
# given collection. This allows you to keep a different placehoolder
# for each stream. This example sets the timeshifting factor to a
# differnt value for each of the 5 streams.

BEGIN { 
    coll = openaudio("prokof.au"); 
    for(i = 0; i < 5; i++)  {
	setstream(i);
	colls[i] = newcollection(coll);
	wins[i] = getwindow(colls[i], FIRST);
	seteffect(TIME, 1-.01*i);
    }
}


/[0-9]+/ { 
	lastwin = wins[$0];
	wins[$0] = getwindow(colls[$0], NEXT);
	play(wins[$0]);
}
