#ifndef __MO_DATA__
#define __MO_DATA__

#include "SoundFileIO.h"
#include "FeatMatrix.h"
#include "FileName.h"
#include "System.h"

#include <string>
#include <vector>
using namespace std;


/*
enum MoNodeType
{
    MO_FILE = 1,
    MO_WINDOW,
    MO_COLLECTION,
		MO_ITERATOR,
		MO_NULL
};



struct MoThing
{
    unsigned int type;
		unsigned int global_id;
    MoThing()
    {
			type = MO_NULL;
			global_id = 0;
    }
		~MoThing() {}
};

struct MoCollection;
struct MoFile;
struct MoWindow;

struct MoFile;

struct MoWindow : public MoThing
{  
	MoFile *file;
	unsigned int file_index;
	unsigned int sample_index;
	unsigned int length;
	unsigned int window_id;
	MoWindow()
	{
		type = MO_WINDOW;
		file = NULL;
		file_index = sample_index = length = window_id = global_id = 0;
	}
};


struct MoCollection : public MoThing
{
		vector<MoWindow *> windows;
		unsigned int collection_id;
		unsigned int position;

		MoCollection() {
			type = MO_COLLECTION;
			global_id = collection_id = position = 0;
		}
		MoCollection(MoCollection *col) {
			type = MO_COLLECTION;
			global_id = collection_id = position = 0;
			for(int i = 0; i < col->windows.size(); i++)
				windows.push_back(col->windows[i]);
		}
		int addWindow(MoWindow *window) { windows.push_back(window); return 1; }
		int addWindow(MoWindow *window, MoWindow *place) {
			int pos = 0;
			while(pos < windows.size() && place->window_id != windows[pos]->window_id) pos++;
			if(pos == windows.size()) return 0;
			windows.insert(windows.begin()+pos, window);
			if(position >= pos) position++;
			if(position == windows.size()) position = 0;
		}
		int deleteWindow(MoWindow *window) {
			int pos = 0;
			while(pos < windows.size() && window->window_id != windows[pos]->window_id) pos++; 
			if(pos == windows.size()) return 0;
			windows.erase(windows.begin() + pos);
			if(position > pos) position--;
			if(position == windows.size()) position = 0;
			return 1;
		}
};
*/

struct MoThing;
struct MoWindow;
struct MoCollection;
struct MoFile;


#define NFEATURES 3
#define WSIZE 2048 
#define END 0

class Database
{
	private:
		static Database *instance;
		string base;

	protected:
		Database()
		{
			instance = 0;
		}
		~Database();
    vector<MoThing *> m_things;
		vector<MoWindow *> m_windows;
		vector<MoCollection *> m_collections;

public:
		static Database *Instance()
		{
			if(instance == 0) instance = new Database();
			return instance;
		}
    void init(const string &dir, int winsize, int hopsize);

    unsigned int addFile(MoFile *file);
    unsigned int addCollection(MoCollection *collection);
		unsigned int addWindow(MoWindow *window);
		
    MoCollection *getCollection(unsigned int index);
		MoFile *getFile(const string &file);
		MoFile *getFile(int collectid);
		MoWindow *getWindow(unsigned int index);
	
		string baseFileName(MoFile *mofile);
		int winSize, hopSize;
};

#endif
