 /*
 *  Mixer.cpp
 *  mosievius
 *
 *  Created by Ari Lazier on Sun Mar 30 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "Mixer.h"
#include "MohAwk.h"
#include <iostream>


Mixer *Mixer::instance = 0;

int callback(char* buffer, int buffer_size, void *data)
{
	Mixer *mixer = Mixer::Instance();
	mixer->setBuffer((float *)buffer, buffer_size);
	
	MohAwk *mohawk = MohAwk::Instance();
	mohawk->tick(buffer_size, mixer->inBuffer);
	return 0;
}

int
Mixer::startAudio(int size, int chans)
{
	if(running == FALSE)
	{
		channels = chans;
		bufferSize = size;
		inBuffer.create(bufferSize*channels);
		try
    {
	io = new RtAudio();
 	RtAudio::RTAUDIO_DEVICE device;
	io->getDeviceInfo(1, &device);
	int srate = 0;
	if(device.nSampleRates == -1)
	{
		if(44100 >= device.sampleRates[0] && 44100 < device.sampleRates[1]) srate = 44100;
		else if(44100 < device.sampleRates[0]) srate = device.sampleRates[0];
		else if(44100 > device.sampleRates[1]) srate = device.sampleRates[1];
	}
 	else for(int min = 44100, i = 0; i < device.nSampleRates; i++)
		if(abs(device.sampleRates[i]-44100) < min)
		{
			srate = device.sampleRates[i];
			min = abs(srate-44100);
		}
	delete io;	
        io = new RtAudio(&soundstream, 0, channels, 0, channels, RtAudio::RTAUDIO_FLOAT32, srate, &bufferSize, 4);
    }
    catch(RtError &error) { return 0; }
		io->setStreamCallback(soundstream, &(callback), (void *)(this));
		io->startStream(soundstream);
		running = TRUE;
		return 1;
	}
	return 0;
}

int
Mixer::stopAudio()
{
	if(running == TRUE)
	{
	  io->stopStream(soundstream);
		io->closeStream(soundstream);
		return 1;
  }
	return 0;
}

int
Mixer::putWin(fvec &win)
{		
	if(win.size() != channels*bufferSize) return 0;
	for(int i = 0; i < channels*bufferSize; i++) outBuffer[i] += win(i);
	return 1;
}

void
Mixer::setBuffer(float *buffer, int size)
{
	int i, j;
	for(i = 0; i < size; i++)
		for(j = 0, inBuffer(i) = 0; j < channels; j++)
		{
			inBuffer(i) += buffer[i*channels+j]/channels;
			buffer[i*channels+j] = 0;
		}
	outBuffer = buffer;
}
	
		
	














