/*
 *  Mixer.h
 *  mosievius
 *
 *  Created by Ari Lazier on Sun Mar 30 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#if !defined(__Mixer_h)
#define __Mixer_h

#include <stdlib.h>
#include "RtAudio.h"
#include "fvec.h"

#define BUF_SIZE 2048

class Mixer
{
	private:
		static Mixer *instance;
		RtAudio *io;
		bool running;
		int soundstream;
		int channels;
		int bufferSize;
		float *outBuffer;
		
	protected:
		Mixer()
		{
			instance = 0;
			running = false;
		}
		~Mixer();
	
	public:
		fvec inBuffer;
		static Mixer *Instance()
		{
			if(instance == 0) instance = new Mixer();
			return instance;
		}
		int startAudio(int s = BUF_SIZE, int cs = 2);	// start audio with specifies # of channels and buffer size
		int stopAudio();															// stop audio
		void setBuffer(float *buffer, int size);			// tell streams to give me samples
		int putWin(fvec &win);												// lets streams give samples
		fvec &getWin()																// get input window
		{
			return inBuffer;
		}
		int nChannels()
		{
			return channels;
		}

};


#endif
