#include "MoThing.h"
#include "FileName.h"
#include "SoundFileIO.h"
#include "FeatMatrix.h"
#include <string>



struct MoWindow;

struct MoIterator : public MoThing
{
	unsigned int iterator_id;
	MoIterator() {
		type = MO_ITERATOR;
		global_id = iterator_id = 0;
	}
};



struct MoCollection : public MoThing
{
		vector<MoWindow *> windows;
		unsigned int collection_id;
		unsigned int position;

		MoCollection();
		MoCollection(MoCollection *col);
		
		static int copy(unsigned int moid);
		int addWindow(MoWindow *window);
		int addWindow(MoWindow *window, MoWindow *place);
		int deleteWindow(MoWindow *window);

		static MoCollection *get(int);
};


struct MoFile : public MoCollection
{
	FileName *filename;
	SoundFileIO *src;
	FeatMatrix *matrix;
	MoFile();
	MoFile(const string &file, int winSize, int hopSize);
		
	static MoFile *get(const string &name);
	static MoFile *get(int fileid);
	int extract();
};

