/*
 *  Stream.h
 *  mosievius
 *
 *  Created by Ari Lazier on Sat Apr 12 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#if !defined(__Stream_h)
#define __Stream_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fvec.h"

#define NEFFECTS 5
#define SRAT  0
#define PITH 1
#define TIME  2
#define HOPSZ 3
#define PANAN 4
#define PANRT 5

class Stream
{
	private:
		int winSize, hopSize, tickSize, outSamples, hop[3], full_buffers;
		int solaSamples, cur_buffer, num_buffers, cur_time;
		float inSample, pitchSample, pitch, time, srate, hopSamples, angle, panRate;
		fvec outWin, panWin, *tswin, win;
		int timeshift(float time, float pitch);
		float sinc(float x);
		bool tickable;

	public:
		Stream(const string str, int winsize, int hopsize, int ticksize);
		string name;
		void process();
		void addwin(int window, fvec &inWin);
		int play(int i);
		int effects(int effect, float value);
		void tick(int size);
};




#endif
