BEGIN {
	collection = extract("prokof.au");

	nfeatures = 4;	
	#features[0] = features[1] = SFM;
	#features[2] = features[3] = FLUX;
	features[0] = features[1] = CENTROID;
	features[2] = features[3] = RMS;
	#tog[0] = tog[2] = tog[4] = tog[6] = 1;
	#tog[1] = tog[3] = tog[5] = tog[7] = 0;
	tog[0] = tog[2] = 1;
	tog[1] = tog[3] = 0;


	for(i = 0; i < nfeatures; i++)
	{
		mins[i] = min(collection, features[i]); 
		maxs[i] = max(collection, features[i]);
		grain[i] = (maxs[i] - mins[i]) / 128.0;

		if(tog[i] == 1) thresh[i] = mins[i];
		else thresh[i] = maxs[i];
	}

	volume = 2;
	pshift = 1;
    hopsz = 512;
	sola = 1024;
	nwins = size(collection);
	win = getwindow(collection, FIRST);
	minlen = 1;
	maxwait = 10;
	skip = 0;

	weight = 0;
	seglen = 0;
	curwin = 0;
	supert = 1;
}


function test(n) {
t = 1;
	for(i = 0; i < nfeatures; i++) 
	{
		feat = getfeature(n, features[i]);
		t = t && ((tog[i]==1 && feat>=thresh[i]) || (tog[i]==0 && feat<=thresh[i]));
	}
	return t;
}

/ONTICK/ {
	if(curwin >= seglen)
	{
		seglen = 0;
		skip = 0;
		curwin = 0;
		first = win;
		win = getwindow(collection, NEXT);
		while(test(win) == 0 && win != first)
		{
			skip++;
			win = getwindow(collection, NEXT);
		}
		while(test(win) == 1 && win != first && seglen < 20)
		{
			seg[seglen++] = win;
			win = getwindow(collection, NEXT);
		}
	}
	if(seglen > 0) 
	{	
		tshift = supert * ( 1 + weight * ((seglen + skip) / seglen - 1) );
		seteffect(TSHIFT, tshift);
		seteffect(HOPSZ, hopsz);
		seteffect(SOLA, sola);
		play(seg[curwin++], volume);
	}
}

/ControlChange/ {
 	if(MDATA1 < nfeatures) 
	{
		thresh[MDATA1] = MDATA2*grain[MDATA1] + mins[MDATA1];
		changed = 1;
	}
	else if(MDATA1 == 4) supert = MDATA2 / 64.0;
	else if(MDATA1 == 5) sola = MDATA2 * 10;
	else if(MDATA1 == 6) hopsz =  32 + MDATA2 * 8;
	else if(MDATA1 == 7) volume = MDATA2 / 64.0;
	else if(MDATA1 == 8) weight = MDATA2 / 127.0;
}

/PitchBend/ { 
	seteffect(PSHIFT,  MDATA2 / 64.0);
}


