/*
 *  Accents.h
 *  
 *
 *  Created by Ari Lazier on Thu Jun 26 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */


#if !defined(__ACCENTS_h)
#define __ACCENTS_h

#include "System.h"
#include "Hamming.h"
#include "fvec.h"
#include "MagFFT.h"
#include "Filter.h"
#include <iostream>

class Accents : public System
{

private:
	Hamming *hamming;
	MagFFT *fft;
	fvec bandborders;
	int nbands, nsigs;
	float minfreq, maxfreq;
	float gamma, dubbya, beta;
	
	fvec fft_, ham_;
	fvec bandpower;
	fvec smoothed, oldsmoothed;
	fvec differ;
	fvec num, den;
	
	Filter **butter;
	
	void init(int bands);
	
public:
	Accents();
	Accents(int insize, int hopsize, int bands);
	~Accents();
	void process(fvec &in, fvec& out);

};

#endif
