/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/




/**
   \class  Extractor
   \brief  Interface for extractors.

   Abstract base class used as interface for extractors. Extractors iterate
   (obviously) over a MSignal possibly calculating feature values and
   optionally storing them to a FeatMatrix.   
*/


#include "Extractor.h"




Extractor::Extractor(MSignal* src)
{
  src_ = src;
}


Extractor::~Extractor()
{
}

void
Extractor::extract()
{
  extract(0, src_->iterations());
}

void
Extractor::extract(FeatMatrix& res)
{
  extract(0, src_->iterations(), res);
}

