/*
** Copyright (C) 2000 George Tzanetakis <gtzan@cs.princeton.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
   \class Mp3FileIO
   \brief SoundFileIO for .au (.snd) soundfiles
   
   SoundFileIO reader/writer for .au (.snd) sound files.
   (Next, Sun audio format). 
*/



/* Mp3FileIO:
   Soundfile reader/writer for .snd (.au) sound file format. 
*/


#if !defined(__Mp3FileIO_h)
#define __Mp3FileIO_h






#include <stdio.h>
#include "MSignal.h"
#include "defs.h"
#include "SoundFileIO.h"
#include "FileName.h"
#include "Gmpg.h"

#include <string.h>
using namespace std;

      


class Mp3FileIO: public SoundFileIO
{
private:
  Gmpg *gmpg_;
public:
  Mp3FileIO(string filename, int mode);
  ~Mp3FileIO();
  void init();
  int check_type();
  void get(fvec &win, unsigned long index);
  void put(fvec &win, unsigned long index);
};




#endif

	
